data StrOp 
  = Clear
  | Remove Char
  | Replace Char Char
  | Add Char deriving (Show)

process :: StrOp -> String -> String
process Clear _ = ""
process (Remove c) s = filter (/= c) s
process (Replace c1 c2) s = map f s
  where f x = if x == c1 then c2 else x
process (Add c) s = c:s

processAll :: [StrOp] -> String -> String
processAll [] s = s
processAll (op : rest) s = processAll rest $ process op s

deleteAll :: String -> String -> String
deleteAll s1 s2 = processAll (map (\c -> Remove c) s1) s2