data TreeMap a b =
      Node (a, b) (TreeMap a b) (TreeMap a b)
    | Tip
    deriving (Eq, Show)

leaf a = Node a Tip Tip

add a Tip = leaf a
add a (Node x xl xr)
    | fst a < fst x = Node x (add a xl) xr
    | otherwise     = Node x xl (add a xr)

size Tip = 0
size (Node _ lx rx) = 1 + size lx + size rx

treeToList Tip = []
treeToList (Node a lx rx) =
    treeToList lx ++ a : treeToList rx

listToTree xs = foldr add Tip xs

ltt xs = listToTree $ zip xs xs
