package foo;

import java.io.*;
import java.util.ArrayList;
import java.util.List;

public class MyInputStreamReader {
    public static InputStream openFileInputStream(String fileName) {
        FileInputStream stream = null;

        try {
            stream = new FileInputStream(fileName);
        }
        catch (FileNotFoundException e) {
            e.printStackTrace();
            System.out.println(e.getLocalizedMessage());
        }

        return stream;
    }

    public static InputStream openSystemInputStream() {
        return System.in;
    }

    public static List<String> read(InputStream stream) {
        ArrayList<String> xs = new ArrayList<String>();

        try {
            String str = new String();
            char[] buf = new char[0x400];

            InputStreamReader reader = new InputStreamReader(stream);

            int n;
            int i = 0;
            while ((reader.read(buf)) != -1) {
                xs.add(new String(buf));
            }
        }
        catch (Exception e) {
            e.printStackTrace();
            System.out.println(e.getLocalizedMessage());
        }

        return xs;
    }
}
