#include <sys/socket.h>
#include <stdlib.h>
#include <stdio.h>
#include <arpa/inet.h>
#include <string.h>
#include <unistd.h>

#define SERVER_ADDRESS "127.0.0.1"

int main(int argc, char *argv[]) {
    if(argc < 3) return -1;

    const int SERVER_PORT = atoi(argv[1]);

    int sd;
    sd = socket(PF_INET, SOCK_STREAM, 0);

    struct sockaddr_in addr;
    addr.sin_family = AF_INET;
    addr.sin_port = htons(SERVER_PORT);
    addr.sin_addr.s_addr = inet_addr(SERVER_ADDRESS);

    bind(sd, (struct sockaddr *) &addr, sizeof(struct sockaddr_in));
    connect(sd, (struct sockaddr *) &addr, sizeof(struct sockaddr_in));

    FILE *fin = fopen(argv[2], "r");
//    FILE *fout = fopen("out", "w");
    char buf[BUFSIZ];
    int sent = 42;
    int m = strlen(argv[2]) + 1;

    for(int n = 0; n < m && sent > 0; n += sent) {
        sent = send(sd, argv[2] + n, m - n, 0);
//        fwrite(argv[2] + n, 1, m - n, fout);
    }
    
    int sentBytes = 0;

    while(m = fread(buf, 1, BUFSIZ, fin)) {
        sent = 42;

        for(int n = 0; n < m && sent > 0; n += sent) {
            sent = send(sd, buf + n, m - n, 0);
            sentBytes += sent;
//            fwrite(buf + n, 1, m - n, fout);
        }
    }
    printf("sent\n\t%s\n\t%d\n", argv[2], sentBytes);

    fclose(fin);
    close(sd);
    return 0;
}

// vim: set ts=4 sts=4 sw=4:
