#include <sys/socket.h>
#include <arpa/inet.h>

#include <pthread.h>

#include <cstring>
#include <iostream>

using namespace std;

void *send(void *_) {
//    const char address[] = "255.255.255.255";
    const char address[] = "127.0.0.1";
    const int port = 5000;
    int broadcast = 1;

    char bornMsg[8] = "IBORN";
    char aliveMsg[8] = "IALIVE";

    int sock;
    sockaddr_in addr;

    int sent;

// Initialization
    sock = socket(PF_INET, SOCK_DGRAM, IPPROTO_UDP);

    addr.sin_family = AF_INET;
    addr.sin_port = htons(port);
    addr.sin_addr.s_addr = inet_addr(address);

    setsockopt( sock
              , SOL_SOCKET
              , SO_BROADCAST
              , &broadcast
              , sizeof(broadcast));

// Send some messages
    sent = sendto( sock
                 , bornMsg
                 , strlen(bornMsg)
                 , 0
                 , (const sockaddr *) &addr
                 , sizeof(sockaddr_in)
                 );
 
    while(true) {
        sent = sendto( sock
                     , aliveMsg
                     , strlen(aliveMsg)
                     , 0
                     , (const sockaddr *) &addr
                     , sizeof(sockaddr_in)
                     );

        for(int i = 0; i < sent; i++)
            cout << aliveMsg[i];
        cout << "\t-->\t"
             << inet_ntoa(addr.sin_addr)
             << endl;
        sleep(2);
    }

    close(sock);
}

void *recv(void *_) {
    const char address[] = "0.0.0.0";
    const int port = 5000;

    int sock;
    struct sockaddr_in addr;
    int addrlen = sizeof(addr);

// Wut?
    sock = socket(PF_INET, SOCK_DGRAM, IPPROTO_UDP);

    addr.sin_family = AF_INET;
    addr.sin_port = htons(port);
    addr.sin_addr.s_addr = inet_addr(address);

    bind(sock, (sockaddr*) &addr, sizeof(addr)); // Is it really need?

// Recive some crap
    while(true) {
        char buf[8];

        memset(buf, 0, sizeof(buf));
        recvfrom( sock
                , buf
                , sizeof(buf)
                , 0
                , (struct sockaddr *) &addr
                , (socklen_t *) &addrlen
                );
//        getsockname(sock, addr, &addrlen);
        cout << buf
             << "\t<--\t"
             << inet_ntoa(addr.sin_addr)
             << endl;
    }

    close(sock);
}

int main() {
    pthread_t sendThread;
    pthread_t recvThread;

// Start sending
    pthread_create(&sendThread, NULL, send, NULL);
    pthread_detach(sendThread);

// Start receiving
    pthread_create(&recvThread, NULL, recv, NULL);
    pthread_detach(recvThread);

// main loop, lol
    while(true) {
    }

    return 0;
}

// vim: set ts=4 sts=4 sw=4:

