#include <sys/socket.h>
#include <stdlib.h>
#include <stdio.h>
#include <arpa/inet.h>
#include <string.h>
#include <unistd.h>
#include <pthread.h>
#include <vector>

#define ADDRESS "127.0.0.1"

void *foo(void *cl) {
    int client = *((int *) cl);

    char buf[BUFSIZ];
    char q[BUFSIZ] = "out";
    FILE *fout;
    int recvd;
    int recvdBytes = 0;

    memset(buf, 0, BUFSIZ);
    memset(q, 0, BUFSIZ);

// Recieve name and bind file descriptor
    if(recvd = recv(client, buf, BUFSIZ, 0)) {
        int i;

        for(i = 0; buf[i]; i++)
            q[i] = buf[i];

        fout = fopen(q, "w");
        fwrite(buf + i + 2, 1, recvd - i - 1, fout);

        recvdBytes += recvd - i - 1;
    }

// Recieve file
    while(recvd > 0) {
        memset(buf, 0, BUFSIZ);
        if((recvd = recv(client, buf, BUFSIZ, 0)) > 0) {
            recvdBytes += recvd;
            fwrite(buf, 1, recvd, fout);
        }
    }
    printf("received\n\t%s\n\t%d\n", q, recvdBytes);
    
    fclose(fout);
    close(client);
}

struct Client {
    int sock;
    int addrlen;
    sockaddr_in addr;
    pthread_t th;
};

int main(int argc, char *argv[]) {
    if(argc < 2)
        return -1;

    const int PORT = atoi(argv[1]);

    int sd;
    sd = socket(PF_INET, SOCK_STREAM, 0);

// Initialization?
    sockaddr_in addr;
    addr.sin_family = AF_INET;
    addr.sin_port = htons(PORT);
    addr.sin_addr.s_addr = inet_addr(ADDRESS);

    bind(sd, (sockaddr *) &addr, sizeof(sockaddr_in));

    listen(sd, 0xa);

// Action?
    std::vector<Client *> clients; // FIXME Clean it

    while(1) {
        Client *cli = new Client;
        clients.push_back(cli);

        cli->addrlen = sizeof(sockaddr_in);
        cli->sock = accept( sd
                          , (sockaddr *) &(cli->addr)
                          , (socklen_t *) &(cli->addrlen)
                          );

//        foo((void *) &(cli->sock)); // Wanna 1 thread?
        pthread_create( &(cli->th)
                      , NULL
                      , foo
                      , (void *) &(cli->sock));
        pthread_detach(cli->th);
    }

    close(sd);

    return 0;
}

// vim: set ts=4 sts=4 sw=4:
